
module Foreign.C.String.Generalised (IsCString(..), withCString) where

import Foreign.C.String (CString, peekCString, newCString)
import Foreign.Marshal.Alloc (free)

class IsCString a where
    toCString :: a -> IO CString
    fromCString :: CString -> IO a
    finishedWithCString :: a -> CString -> IO ()
    finishedWithCString _ s = free s

withCString :: IsCString str => str -> (CString -> IO a) -> IO a
withCString str f = do str' <- toCString str
                       r <- f str'
                       finishedWithCString str str'
                       return r

instance IsCString CString where
    toCString s = return s
    fromCString s = return s
    finishedWithCString _ _ = return ()

instance IsCString String where
    toCString s = newCString s
    fromCString s = peekCString s

